#property copyright "bonten"
#property link      "bd0ppens@gmail.com"

#include <stdlib.mqh>

// ea based on misakas secelper original idea
// NOT PROFITABLE

extern bool UseTrailingStop;
extern double StopLoss = 20.0;
extern double TakeProfit = 10.0;
extern double Lot = 0.1;
extern bool UseMM;
extern int Risk;
extern double MinimumMargin = 1000.0;
extern int Magic = 56757;

int g_dir;
bool g_entry = true;
bool g_buy;
int g_trailing_counter = 1;
int g_ticketNumber = -1;
double g_lot;

int init() 
{
   if (UseMM) g_lot = lot_size();
   else g_lot = Lot;
   return (0);
}

int deinit() 
{
   return (0);
}

bool check_indis(bool buy, int shift, bool check_all)
{
   int nonlagdot_mode = 2;
   int hmaV2A_mode = 2;
   int hmaV2B_mode = 2;
   string mode = "SELL";
   
   if (buy)
   {
      nonlagdot_mode = 1;
      hmaV2A_mode = 1;
      hmaV2B_mode = 1;
      mode = "BUY"; 
   }
  
   double nonlagdot = iCustom(NULL, 0, "nonlagdotMS", 0, 30, 0, 0, 1, 0, 0, 0, nonlagdot_mode, shift);
   double hmaV2A = iCustom(NULL, 0, "HMA_v2", 0, 30, 0, 1, 0, 0, 0, hmaV2A_mode, shift);
   double hmaV2B = iCustom(NULL, 0, "HMA_v2", 0, 50, 0, 1, 0, 0, 0, hmaV2B_mode, shift);
   double fisher = iCustom(NULL, 0, "Fisher~1", 30, 0.3, 0.3, 0, shift);
   
   if (nonlagdot > 350.0) nonlagdot = 0;
   if (hmaV2A > 350.0) hmaV2A = 0;
   if (hmaV2B > 350.0) hmaV2B = 0;
   
   bool fisher_check;
   if (buy) fisher_check = fisher > 0.0;
   else fisher_check = fisher < 0.0;
     
   Print(mode, " --- nonlagdot = ", nonlagdot, " hmaV2A = ", hmaV2A, " hmaV2B = ", hmaV2B); 
   
   if (check_all) return (nonlagdot > 0.0 && hmaV2A > 0.0 && hmaV2B > 0.0 && fisher_check);
   else return (nonlagdot > 0.0 || hmaV2A > 0.0 || hmaV2B > 0.0 || fisher_check);
}

bool is_entry(bool& buy, int& dir)
{
   // misakas secelper entry:
   // at least all indis must have 2 bars/dots of the same color
   
   if (check_indis(false, 1, true) && check_indis(false, 2, true))
   {    
      Print("Entry signal - SELL");
            
      buy = false;
      dir = OP_SELL;
      return (true);
   }
   if (check_indis(true, 1, true) && check_indis(true, 2, true))
   {
      buy = true;
      dir = OP_BUY;
      return (true);
   }
   return (false);
}

bool is_exit(bool buy)
{
   // misakas secelper exit:
   // nonlagdot must have changed color
   
   double nonlagdot;
      
   if (buy)
   {
      nonlagdot = iCustom(NULL, 0, "nonlagdotMS", 0, 30, 0, 0, 1, 0, 0, 0, 2, 1);
      if (nonlagdot > 350.0) nonlagdot = 0;
      if (nonlagdot > 0.0)
      {
         Print("Exit signal - BUY");
         return (true);
      } 
   }
   else
   {
      nonlagdot = iCustom(NULL, 0, "nonlagdotMS", 0, 30, 0, 0, 1, 0, 0, 0, 1, 1);
      if (nonlagdot > 350.0) nonlagdot = 0;
      if (nonlagdot > 0.0)
      {
         Print("Exit signal - SELL");
         return (true);
      } 
   }
   return (false);
}

void trail_stoploss(int ticket_number, double trailing_stop, int& trailing_counter)
{
   OrderSelect(ticket_number, SELECT_BY_TICKET);
   if (OrderCloseTime() == 0)
   {
      if (OrderType() == OP_BUY && Bid - OrderOpenPrice() >= trailing_counter * trailing_stop * Point)
      {
         OrderModify(ticket_number, OrderOpenPrice(), Bid - trailing_stop * Point, 0.0, 0, Purple);
         trailing_counter++;
      }
      else if (OrderOpenPrice() - Ask >= trailing_counter * trailing_stop * Point)
      {
         OrderModify(ticket_number, OrderOpenPrice(), Ask + trailing_stop * Point, 0.0, 0, Purple);
         trailing_counter++;
      }
   }
}

void close_order(int ticket_number, bool buy, double lot)
{
   double bid_ask;
   
   if (buy) bid_ask = Bid;
   else bid_ask = Ask;
   bool res = OrderClose(ticket_number, lot, bid_ask, 3, Red);        
   while (!res && GetLastError() == 138)
   {
      RefreshRates();
      if (g_buy) bid_ask = Bid;
      else bid_ask = Ask;
      res = OrderClose(ticket_number, lot, bid_ask, 3, Red);
   }
}

double lot_size()
{
   if (StopLoss > 0.0) return (NormalizeDouble((AccountFreeMargin() / (StopLoss * 10)) * Risk * Point, 2)  * 10);
   else return (Lot);
}

int start() 
{
   double bid_ask;
   double tp = 0.0;
   double sl = 0.0;
   
   // currently no orders open 
   if (g_entry)
   {
      // check if entry 
      if (is_entry(g_buy, g_dir))
      {
         if (AccountFreeMargin() > MinimumMargin)
         {
            int col;
            if (g_buy) 
            {
               col = Blue;
               bid_ask = Ask;
               if (TakeProfit > 0.0) tp = bid_ask + TakeProfit * Point;
               if (StopLoss > 0.0) sl = bid_ask - StopLoss * Point;
            }
            else 
            {
               col = Red;
               bid_ask = Bid;
               if (TakeProfit > 0.0) tp = bid_ask - TakeProfit * Point; 
               if (StopLoss > 0.0) sl = Ask + StopLoss * Point;
            }
            g_ticketNumber = OrderSend(Symbol(), g_dir, g_lot, bid_ask, 3, sl, tp, "misakas_secelper_bonten", Magic, 0, col);
            g_entry = false;
         }
      }
   }
   else
   {
      if (UseTrailingStop && StopLoss > 0.0)
      {
        trail_stoploss(g_ticketNumber, StopLoss, g_trailing_counter);
      }
       
      // check for exit
      if (is_exit(g_buy))
      {
         g_entry = true;   
         g_trailing_counter = 1;
         OrderSelect(g_ticketNumber, SELECT_BY_TICKET);
         if (OrderCloseTime() == 0) close_order(g_ticketNumber, g_buy, g_lot);
      }
   }
   return (0);
}

     